%define _unpackaged_files_terminate_build 0

Summary:        Modular SIP user-agent with audio and video support
Name:           baresip
Version:        3.9.0
Release:    1%{?dist}
License:        BSD-3-Clause
URL:            https://github.com/baresip/baresip
Source0:        https://github.com/baresip/baresip/archive/v%{version}/%{name}-%{version}.tar.gz
Source1:        com.github.baresip.desktop
Source10:       https://gitlab.gnome.org/GNOME/adwaita-icon-theme/-/raw/1e1d692148e8ab958bfea4188f8575b673804e09/Adwaita/scalable/status/call-incoming-symbolic.svg
Source11:       https://gitlab.gnome.org/GNOME/adwaita-icon-theme/-/raw/1e1d692148e8ab958bfea4188f8575b673804e09/Adwaita/scalable/status/call-outgoing-symbolic.svg
Source12:       https://gitlab.gnome.org/GNOME/adwaita-icon-theme/-/raw/master/COPYING#/COPYING.adwaita-icon-theme
Source13:       https://gitlab.gnome.org/GNOME/adwaita-icon-theme/-/raw/master/COPYING_CCBYSA3#/COPYING_CCBYSA3.adwaita-icon-theme
Source14:       https://gitlab.gnome.org/GNOME/adwaita-icon-theme/-/raw/master/COPYING_LGPL#/COPYING_LGPL.adwaita-icon-theme
BuildRequires:  cmake
BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires:  libre-devel >= 3.9.0
BuildRequires:  openssl-devel

%description
A modular SIP user-agent with support for audio and video, and many IETF
standards such as SIP, SDP, RTP/RTCP and STUN/TURN/ICE for both, IPv4 and
IPv6.

Additional modules provide support for audio codecs like Codec2, G.711,
G.722, G.726, GSM, L16, MPA and Opus, audio drivers like ALSA, GStreamer,
JACK Audio Connection Kit, Portaudio, and PulseAudio, video codecs like
AV1, VP8 or VP9, video sources like Video4Linux, video outputs like SDL2
or X11, NAT traversal via STUN, TURN, ICE, and NAT-PMP, media encryption
via TLS, SRTP or DTLS-SRTP, management features like embedded web-server
with HTTP interface, command-line console and interface, and MQTT.

%package devel
Summary:        Development files for the baresip library
Requires:       %{name} = %{version}-%{release}
Requires:       pkgconfig

%description devel
The baresip-devel package includes header files and libraries necessary
for developing programs which use the baresip C library.

%package aac
Summary:        AAC audio codec module for baresip
BuildRequires:  fdk-aac-free-devel
Requires:       %{name} = %{version}-%{release}

%description aac
Baresip is a modular SIP user-agent with audio and video support.

This module provides the Advanced Audio Coding (AAC) audio codec.

%package alsa
Summary:        ALSA audio driver for baresip
BuildRequires:  alsa-lib-devel
Requires:       %{name} = %{version}-%{release}

%description alsa
Baresip is a modular SIP user-agent with audio and video support.

This module provides the Advanced Linux Sound Architecture (ALSA) audio
driver.

%package av1
Summary:        AV1 video codec module for baresip
BuildRequires:  libaom-devel
Requires:       %{name} = %{version}-%{release}

%description av1
Baresip is a modular SIP user-agent with audio and video support.

This module provides the AV1 video codec, an open, royalty-free video
coding format developed as a successor to the VP9 video codec.

%package codec2
Summary:        Codec 2 audio codec module for baresip
BuildRequires:  codec2-devel
Requires:       %{name} = %{version}-%{release}

%description codec2
Baresip is a modular SIP user-agent with audio and video support.

This module provides the Codec 2 audio codec, an Open Source speech codec
designed for communications quality speech between 700 and 3200 bit/s.

%package ctrl_dbus
Summary:        D-BUS communication channel control module for baresip
BuildRequires:  %{_bindir}/gdbus-codegen
BuildRequires:  pkgconfig(glib-2.0)
BuildRequires:  pkgconfig(gio-unix-2.0)
Requires:       %{name} = %{version}-%{release}

%description ctrl_dbus
Baresip is a modular SIP user-agent with audio and video support.

This module provides a communication channel to control and monitor
baresip via D-BUS.

%package g722
Summary:        G.722 audio codec module for baresip
BuildRequires:  spandsp-devel
Requires:       %{name} = %{version}-%{release}

%description g722
Baresip is a modular SIP user-agent with audio and video support.

This module provides the G.722 audio codec, often used for HD voice.

%package g726
Summary:        G.726 audio codec module for baresip
BuildRequires:  spandsp-devel
Requires:       %{name} = %{version}-%{release}

%description g726
Baresip is a modular SIP user-agent with audio and video support.

This module provides the G.726 audio codec.

%package gst
Summary:        GStreamer audio source driver for baresip
BuildRequires:  pkgconfig(gstreamer-1.0)
Requires:       %{name} = %{version}-%{release}

%description gst
Baresip is a modular SIP user-agent with audio and video support.

This module uses the GStreamer 1.0 framework to play external media and
provides them as an internal audio source.

%package gtk
Summary:        GTK+ menu-based user interface module for baresip
BuildRequires:  pkgconfig(gtk+-3.0) >= 3.0
BuildRequires:  pkgconfig(glib-2.0) >= 2.32
BuildRequires:  desktop-file-utils
Requires:       adwaita-icon-theme >= 3.31.91-1
Requires:       %{name} = %{version}-%{release}
Requires:       (gnome-shell-extension-appindicator if gnome-shell)

%description gtk
Baresip is a modular SIP user-agent with audio and video support.

This module provides a GTK+ menu-based user interface.
Note: GTK+ defaults to the Wayland backend, which baresip does not
support. Use 'GDK_BACKEND=x11 baresip' to override it to Xwayland.

%package jack
Summary:        JACK audio driver for baresip
BuildRequires:  pkgconfig(jack)
Requires:       %{name} = %{version}-%{release}

%description jack
Baresip is a modular SIP user-agent with audio and video support.

This module provides the JACK Audio Connection Kit audio driver.

%package mpa
Summary:        MPA speech and audio codec module for baresip
BuildRequires:  twolame-devel
BuildRequires:  lame-devel
BuildRequires:  mpg123-devel
BuildRequires:  speexdsp-devel
Requires:       %{name} = %{version}-%{release}

%description mpa
Baresip is a modular SIP user-agent with audio and video support.

This module provides the MPA speech and audio codec.

%package mqtt
Summary:        MQTT management module for baresip
BuildRequires:  mosquitto-devel
Requires:       %{name} = %{version}-%{release}

%description mqtt
Baresip is a modular SIP user-agent with audio and video support.

This module provides the Message Queue Telemetry Transport (MQTT)
management module.

%package opus
Summary:        Opus speech and audio codec module for baresip
BuildRequires:  opus-devel
Requires:       %{name} = %{version}-%{release}

%description opus
Baresip is a modular SIP user-agent with audio and video support.

This module provides the Opus speech and audio codec module.

%package pipewire
Summary:        PipeWire audio driver for baresip
BuildRequires:  pkgconfig(libpipewire-0.3)
Requires:       %{name} = %{version}-%{release}

%description pipewire
Baresip is a modular SIP user-agent with audio and video support.

This module provides the PipeWire audio driver.

%package plc
Summary:        Packet Loss Concealment module for baresip
BuildRequires:  spandsp-devel
Requires:       %{name} = %{version}-%{release}

%description plc
Baresip is a modular SIP user-agent with audio and video support.

This module provides the Packet Loss Concealment (PLC) module.

%package portaudio
Summary:        Portaudio audio driver for baresip
BuildRequires:  portaudio-devel
Requires:       %{name} = %{version}-%{release}

%description portaudio
Baresip is a modular SIP user-agent with audio and video support.

This module provides the Portaudio audio driver.

%package pulse
Summary:        PulseAudio audio driver for baresip
BuildRequires:  pkgconfig(libpulse)
Requires:       %{name} = %{version}-%{release}

%description pulse
Baresip is a modular SIP user-agent with audio and video support.

This module provides the PulseAudio audio driver.

%package sdl
Summary:        SDL2 video output driver for baresip
BuildRequires:  SDL2-devel
Requires:       %{name} = %{version}-%{release}

%description sdl
Baresip is a modular SIP user-agent with audio and video support.

This module provides the Simple DirectMedia Layer 2.0 (SDL2) video output
driver.

%package snapshot
Summary:        Snapshot video filter using libpng for baresip
BuildRequires:  libpng-devel
Requires:       %{name} = %{version}-%{release}

%description snapshot
Baresip is a modular SIP user-agent with audio and video support.

This module takes snapshots of the video stream and saves them as PNG
files using libpng.

%package sndfile
Summary:        Audio dumper module using libsndfile for baresip
BuildRequires:  libsndfile-devel
Requires:       %{name} = %{version}-%{release}

%description sndfile
Baresip is a modular SIP user-agent with audio and video support.

This module provides an audio dumper to write WAV audio sample files
using libsndfile.

%package tools
Summary:        Collection of tools and helper scripts for baresip
BuildRequires:  python3-devel
Requires:       %{name} = %{version}-%{release}

%description tools
Baresip is a modular SIP user-agent with audio and video support.

This package provides a collection of tools and helper scripts.

%package vp8
Summary:        VP8 video codec module for baresip
BuildRequires:  libvpx-devel
Requires:       %{name} = %{version}-%{release}

%description vp8
Baresip is a modular SIP user-agent with audio and video support.

This module provides the VP8 video codec, which is compatible with the
WebRTC standard.

%package vp9
Summary:        VP9 video codec module for baresip
BuildRequires:  pkgconfig(vpx) >= 1.3.0
Requires:       %{name} = %{version}-%{release}

%description vp9
Baresip is a modular SIP user-agent with audio and video support.

This module provides the VP9 video codec, which is compatible with the
WebRTC standard.

%package v4l2
Summary:        Video4Linux video source driver for baresip
BuildRequires:  libv4l-devel
Requires:       %{name} = %{version}-%{release}

%description v4l2
Baresip is a modular SIP user-agent with audio and video support.

This module provides the Video4Linux video source driver.

%package x11
Summary:        X11 video output driver for baresip
BuildRequires:  libX11-devel
BuildRequires:  libXext-devel
Requires:       %{name} = %{version}-%{release}

%description x11
Baresip is a modular SIP user-agent with audio and video support.

This module provides the X11 video output driver.

%prep
%autosetup -p1

%build
%cmake \
  -DDEFAULT_CAFILE:PATH="%{_sysconfdir}/pki/tls/certs/ca-bundle.crt" \
  -DDEFAULT_AUDIO_DEVICE:STRING="pipewire" \

%cmake_build

%install
%cmake_install

desktop-file-install --dir=%{buildroot}%{_datadir}/applications/ %{SOURCE1}


install -p -m 0755 tools/fritzbox2%{name} %{buildroot}%{_bindir}/fritzbox2%{name}

%check
%if !0%{?__cmake_in_source_build} && !0%{?__cmake3_in_source_build}
cd %{_vpath_builddir}
%endif
./test/selftest


%files
%license LICENSE
%doc CHANGELOG.md docs/THANKS docs/examples
%{_bindir}/%{name}
%{_libdir}/lib%{name}.so.13*
%dir %{_libdir}/%{name}/
%dir %{_libdir}/%{name}/modules/
%{_libdir}/%{name}/modules/account.so
%{_libdir}/%{name}/modules/aubridge.so
%{_libdir}/%{name}/modules/auconv.so
%{_libdir}/%{name}/modules/aufile.so
%{_libdir}/%{name}/modules/auresamp.so
%{_libdir}/%{name}/modules/ausine.so
%{_libdir}/%{name}/modules/cons.so
%{_libdir}/%{name}/modules/contact.so
%{_libdir}/%{name}/modules/ctrl_tcp.so
%{_libdir}/%{name}/modules/debug_cmd.so
%{_libdir}/%{name}/modules/dtls_srtp.so
%{_libdir}/%{name}/modules/ebuacip.so
%{_libdir}/%{name}/modules/echo.so
%{_libdir}/%{name}/modules/evdev.so
%{_libdir}/%{name}/modules/fakevideo.so
%{_libdir}/%{name}/modules/g711.so
%{_libdir}/%{name}/modules/httpd.so
%{_libdir}/%{name}/modules/httpreq.so
%{_libdir}/%{name}/modules/ice.so
%{_libdir}/%{name}/modules/l16.so
%{_libdir}/%{name}/modules/menu.so
%{_libdir}/%{name}/modules/mixausrc.so
%{_libdir}/%{name}/modules/mixminus.so
%{_libdir}/%{name}/modules/multicast.so
%{_libdir}/%{name}/modules/mwi.so
%{_libdir}/%{name}/modules/natpmp.so
%{_libdir}/%{name}/modules/netroam.so
%{_libdir}/%{name}/modules/pcp.so
%{_libdir}/%{name}/modules/presence.so
%{_libdir}/%{name}/modules/rtcpsummary.so
%{_libdir}/%{name}/modules/selfview.so
%{_libdir}/%{name}/modules/serreg.so
%{_libdir}/%{name}/modules/srtp.so
%{_libdir}/%{name}/modules/stdio.so
%{_libdir}/%{name}/modules/stun.so
%{_libdir}/%{name}/modules/syslog.so
%{_libdir}/%{name}/modules/turn.so
%{_libdir}/%{name}/modules/uuid.so
%{_libdir}/%{name}/modules/vidbridge.so
%{_libdir}/%{name}/modules/vidinfo.so
%{_libdir}/%{name}/modules/vumeter.so
%{_datadir}/%{name}/

%files devel
%{_libdir}/lib%{name}.so
%{_includedir}/%{name}.h
%{_libdir}/pkgconfig/lib%{name}.pc

%files aac
%{_libdir}/%{name}/modules/aac.so

%files alsa
%{_libdir}/%{name}/modules/alsa.so

%files av1
%{_libdir}/%{name}/modules/av1.so

%files codec2
%{_libdir}/%{name}/modules/codec2.so

%files ctrl_dbus
%{_libdir}/%{name}/modules/ctrl_dbus.so

%files g722
%{_libdir}/%{name}/modules/g722.so

%files g726
%{_libdir}/%{name}/modules/g726.so

%files gst
%{_libdir}/%{name}/modules/gst.so

%files gtk
%{_libdir}/%{name}/modules/gtk.so
%{_datadir}/applications/com.github.baresip.desktop

%files jack
%{_libdir}/%{name}/modules/jack.so

%files mpa
%{_libdir}/%{name}/modules/mpa.so

%files mqtt
%{_libdir}/%{name}/modules/mqtt.so

%files opus
%{_libdir}/%{name}/modules/opus.so
%{_libdir}/%{name}/modules/opus_multistream.so

%files pipewire
%{_libdir}/%{name}/modules/pipewire.so

%files plc
%{_libdir}/%{name}/modules/plc.so

%files portaudio
%{_libdir}/%{name}/modules/portaudio.so

%files pulse
%{_libdir}/%{name}/modules/pulse.so

%files sdl
%{_libdir}/%{name}/modules/sdl.so

%files snapshot
%{_libdir}/%{name}/modules/snapshot.so

%files sndfile
%{_libdir}/%{name}/modules/sndfile.so

%files tools
%{_bindir}/fritzbox2%{name}

%files v4l2
%{_libdir}/%{name}/modules/v4l2.so

%files vp8
%{_libdir}/%{name}/modules/vp8.so

%files vp9
%{_libdir}/%{name}/modules/vp9.so

%files x11
%{_libdir}/%{name}/modules/x11.so

%changelog
* Fri Jun 28 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.9.0-1
- initial build
